

#define YT1_LABEL	"AI1 Flow Value""|de|AI1 Durchfluwert"
#define YT1_VALUE	func1_AI_out_value
#define	YT1_LRV		func1_AI_out_lower_range_value
#define YT1_URV		func1_AI_out_upper_range_value
#include "SI_YT.inc"

#define FIRST_LEAP_YEAR     ((double)1984)        /* first leap year after 1/1/1970 GMT               */
#define GMT_YEAR            ((double)1984)        /* 00:00 Jan 1972 GMT                               */
#define DAYS_IN_A_YEAR      ((double)365)         /* # of days in one (non-leap) year                 */
#define SEC_IN_A_YEAR       ((double)31536000)    /* # of seconds in one (non-leap) year              */
#define SEC_IN_A_LEAP_YEAR  ((double)31622400)    /* # of seconds in one leap year                    */
#define SEC_IN_A_DAY        ((double)86400)       /* # of seconds in one day                          */
#define SEC_IN_A_HR         ((double)3600)        /* # of seconds in one hour                         */
#define SEC_IN_A_MIN        ((double)60)          /* # of seconds in one minutes                      */

#define STATUS_NO_ERROR_TEXT    "|001No Errors"
#define STATUS_SIZE             3                 /* size of status array               */


//******************************************************************************
//****	MENU Bar  **************************************************************
//******************************************************************************

MENU Menu_Main_Specialist
{
	LABEL		[main_menu];
	ITEMS
	{
		Menu_S_Device,
		Menu_S_View,
                Menu_S_Observe,
                Table_Main_Specialist
	}
}


//---------------------------------------------------------------------
//    Menu: Device
//---------------------------------------------------------------------

MENU Menu_S_Device
{
	LABEL		[menu_Device];
	ITEMS
	{
		std_NodeAddress,
//		SEPARATOR,
		std_LoadinDevice,
		std_LoadinPC,
//		SEPARATOR,
		OnlineDialog_AI_target_mode,
		OnlineDialog_TB_target_mode,
		OnlineDialog_RS_target_mode,
//		SEPARATOR,
		Menu_simulation,
		OnlineDialog_lowcut,
		OnlineDialog_reset,
		OnlineDialog_write_locking,
		OnlineDialog_ident_number
	}
}


METHOD std_NodeAddress
{
	LABEL		[menu_Device_NodeAddress];
	CLASS 		LOCAL;
	ACCESS		ONLINE;
	DEFINITION
	{
	}
}

METHOD std_LoadinDevice
{
	LABEL		[menu_Device_LoadinDevice];
	CLASS 		LOCAL;
	ACCESS		ONLINE;
	DEFINITION
	{
	}
}

METHOD std_LoadinPC
{
	LABEL		[menu_Device_LoadinPC];
	CLASS 		LOCAL;
	ACCESS		ONLINE;
	DEFINITION
	{
	}
}

MENU Menu_simulation
{
	LABEL		[menu_dialog_simulation];
	ITEMS
	{
		OnlineDialog_simulation_func1_AI
	}
}

//---------------------------------------------------------------------
//    Menu: View
//---------------------------------------------------------------------

MENU Menu_S_View
{
	LABEL		[menu_View];
	ITEMS
	{
		OnlineWindow_AI_display,
		OnlineWindow_yt,
		OnlineWindow_diagnosis,
//		SEPARATOR,
		std_Funktionsleiste,
		std_Statuszeile,
//		SEPARATOR,
		std_Update,
		OnlineWindow_TB_display,
	}
}

MENU Menu_S_Observe
{
	LABEL		[menu_Observe];
	ITEMS
	{
		OnlineWindow_TB_display,
		OnlineWindow_AI_display,
		OnlineWindow_yt
	}
}



METHOD std_Funktionsleiste
{
	LABEL		[menu_View_Toolbar];
	CLASS 		LOCAL;
	ACCESS		ONLINE;
	DEFINITION
	{
	}
}

METHOD std_Statuszeile
{
	LABEL		[menu_View_Statusbar];
	CLASS 		LOCAL;
	ACCESS		ONLINE;
	DEFINITION
	{
	}
}

METHOD std_Update
{
	LABEL		[menu_View_Update];
	CLASS 		LOCAL;
	ACCESS		ONLINE;
	DEFINITION
	{
	}
}

//******************************************************************************
//****	Online-Windows  ********************************************************
//******************************************************************************
//---------------------------------------------------------------------
//    Menu: Options
//******************************************************************************
//****	Online-Windows  ********************************************************
//******************************************************************************

//---------------------------------------------------------------------
//    OnlineWindow: Display
//---------------------------------------------------------------------


MENU OnlineWindow_TB_display
{
  LABEL		[menu_dialog_measure_TB];
  ITEMS {
    Page_display_trans
  }
}

MENU OnlineWindow_AI_display
{
  LABEL		[menu_dialog_measure_AI];
  ITEMS {
    Page_display_out_AI
  }
}


MENU OnlineWindow_display
{
  LABEL		[menu_dialog_measure_AI];
  ITEMS {
    Page_display_out_AI
  }
}



//-----------------
MENU Page_display_out_AI
{
  LABEL		[menu_dialog_outputs_AI];
  ITEMS {
    Page_display_out_func1_AI          // FB1  - Primary value Slot 1
  }
}



//---------------------------------------------------------------------
//    OnlineWindow: Diagnosis
//---------------------------------------------------------------------

MENU OnlineWindow_diagnosis
{
  LABEL		[menu_dialog_diagnosis];
  ITEMS
  {
    Page_diagnosis_general,
    Page_diagnosis_phys_block,
    Page_diagnosis_trans_block,
    Page_diagnosis_func1_AI_block
  }
}

MENU Page_diagnosis_general
{
  LABEL		[menu_dialog_general];
  ITEMS
  {
    phys_tag_desc		(READ_ONLY),
    phys_device_man_id,
    phys_device_id,
    phys_device_ser_num,
    phys_software_rev,
    phys_hardware_rev,
    phys_install_date		(READ_ONLY),
    phys_diagnosis,
    phys_diagnosis_extension
  }
}

MENU Page_diagnosis_phys_block
{
  LABEL		[blk_block_object_PHYSICAL];
  ITEMS
  {
    phys_blk_object,
    phys_blk_parent_class,
    phys_blk_class,
    dummy_blk_dd_reference		(READ_ONLY),
    dummy_blk_dd_rev		        (READ_ONLY),
    phys_blk_profile,
    phys_blk_profile_rev,
    phys_st_rev,
    phys_actual_mode
  }
}

MENU Page_diagnosis_trans_block
{
  LABEL		[blk_block_object_TRANSDUCER];
  ITEMS
  {
    trans_blk_object,
    trans_blk_parent_class,
    trans_blk_class,
    dummy_blk_dd_reference		(READ_ONLY),
    dummy_blk_dd_rev		        (READ_ONLY),
    trans_blk_profile,
    trans_blk_profile_rev,
    trans_st_rev,
    trans_actual_mode
  }
}



  //******************************************************************************
//****	Online-Dialogs  ********************************************************
//******************************************************************************

//---------------------------------------------------------------------
//    OnlineDialog: Reset
//---------------------------------------------------------------------

MENU OnlineDialog_reset
{
  LABEL		[reset];
  ITEMS
  {
    Page_reset_device
  }
}

MENU Page_reset_device
{
  LABEL		[menu_Device];
  HELP		[sitf_menu_reset_device_help];
  ITEMS
  {
    phys_factory_reset,
    phys_diagnosis,
    phys_diagnosis_extension
  }
}

//---------------------------------------------------------------------
//    OnlineDialog: Write Locking
//---------------------------------------------------------------------

MENU OnlineDialog_write_locking
{
  LABEL		[phys_write_locking];
  HELP		[phys_write_locking_help];
  ITEMS
  {
   phys_write_locking
  }
}

MENU OnlineDialog_AI_target_mode
{
  LABEL		[target_mode_AI_block];
  HELP		[target_mode_help];
  ITEMS
  {
   func1_AI_target_mode
  }
}

MENU OnlineDialog_TB_target_mode
{
  LABEL		[target_mode_TB_block];
  HELP		[target_mode_help];
  ITEMS
  {
   trans_target_mode
  }
}

MENU OnlineDialog_RS_target_mode
{
  LABEL		[target_mode_RS_block];
  HELP		[target_mode_help];
  ITEMS
  {
   phys_target_mode
  }
}

MENU OnlineDialog_ident_number
{
  LABEL		[phys_ident_number];
  HELP		[phys_ident_number];
  ITEMS
  {
   phys_ident_number
  }
}


MENU OnlineDialog_lowcut
{
  LABEL		[trans_flow_low_flow_cutoff];
  ITEMS
  {
    Page_lowcut_device
  }
}

MENU Page_lowcut_device
{
  LABEL		[menu_lowcut_TB];
  HELP		[menu_lowcut_TB_help];
  ITEMS
  {
    trans_low_flow_cutoff
  }
}






//******************************************************************************
//****	Methods		********************************************************
//******************************************************************************





//******************************************************************************

MENU download_variables
{
	LABEL		[menu_load_to_PC];
	ITEMS
	{
        // PB: PHYSICAL BLOCK
 	phys_st_rev,
        phys_target_mode,
        phys_tag_desc,
        phys_descriptor,
        phys_message,
        phys_device_man_id,
        phys_device_id,
        phys_device_ser_num,
        phys_software_rev,
        phys_hardware_rev,
        phys_blk_profile,
        phys_blk_profile_rev,
        phys_device_certification,
        phys_install_date,
        phys_ident_number,


        // TB: TRANSDUCER BLOCK
 	trans_st_rev,
        trans_target_mode,
        trans_calibration_factor,
        trans_low_flow_cutoff,
        trans_measurement_mode,
        trans_flow_direction,
        trans_zero_point,
        trans_zero_point_adjust,
        trans_zero_point_units,
        trans_nominal_size,
        trans_nominal_size_units,

        trans_volume_flow_value,
        trans_volume_flow_status_quality,
        trans_volume_flow_status_limit,
        trans_volume_flow_unit,
        trans_volume_flow_lower_limit,
        trans_volume_flow_upper_limit,

        trans_mass_flow_value,
        trans_mass_flow_status_quality,
        trans_mass_flow_status_limit,
        trans_mass_flow_unit,
        trans_mass_flow_lower_limit,
        trans_mass_flow_upper_limit,

        trans_density,
        trans_density_status_quality,
        trans_density_status_limit,
        trans_density_unit,
        trans_temperature,
        trans_temperature_status_quality,
        trans_temperature_status_limit,
        trans_temperature_unit,

        trans_oper_viscosity,     	//53;2;69
        trans_oper_viscosity_unit,	//54;2;70
        trans_oper_pressure,    	//55;2;71
        trans_oper_pressure_unit,	//56;2;72
        trans_pressure_ref,		//57;2;73
        trans_press_ref_unit,		//58;2;74
        trans_oper_temperature,		//59;2;75
        trans_oper_temp_unit,		//60;2;76
        trans_oper_condition,		//61;2;77

        trans_fluid_phase,		//62;2;78
        trans_flow_reference,		//63;2;79
        trans_commission_no,
        trans_model_code,
        trans_fluid_name,

        trans_totalizer,		//67;2;83
        trans_totalizer_units,		//68;2;84
        trans_totalizer_reset,		//69;2;85
        trans_reset_error_bit,		//70;2;86

        trans_dist_version,		//71;2;87
        trans_scale_span_value,  	//72;2;88
        trans_soft_revision,  		//73;2;89
        trans_hard_revision,  		//74;2;90

        trans_percent,			//75;2;91
        trans_percent_units,		//76;2;92
        trans_primary_value,		//77;2;93
        trans_primary_units,		//78;2;94
        trans_hart_dev_stat1,		//79;2;95
        trans_hart_dev_stat2,		//80;2;96
        trans_default_channel,		//81;2;97
	trans_eepr_revision,		//82;2;98
        trans_tb_status_handling,       //83;2;99
        trans_scale_span_unit,          //84;2;100
        trans_wtm_soft_revision,        //85;2;101
        trans_fbk_soft_revision,        //86;2;102
        
        // AI1 FUNCTION BLOCK
        func1_AI_st_rev,
        func1_AI_target_mode,
        func1_AI_channel,
        func1_AI_out_unit,
        func1_AI_out_unit_text,
        func1_AI_out_decimal_point,
        func1_AI_pv_ftime,
        Tab_s_func1_limits,
        func1_AI_pv_lower_range_value,
        func1_AI_pv_upper_range_value,
        func1_AI_out_lower_range_value,
        func1_AI_out_upper_range_value,
        func1_AI_hi_hi_lim,
        func1_AI_hi_lim,
        func1_AI_lo_lim,
        func1_AI_lo_lo_lim,
        func1_AI_alarm_hys,
        func1_AI_out_status,
        func1_AI_out_value,
        func1_AI_out_lower_range_value,
        func1_AI_out_upper_range_value,


    }
}


MENU upload_variables
{
	LABEL		[menu_load_to_device];
	ITEMS
	{
        // PB: PHYSICAL BLOCK
        phys_target_mode,
        phys_tag_desc,
        phys_descriptor,
        phys_message,
        phys_install_date,

        // TB: TRANSDUCER BLOCK
        trans_target_mode,
        trans_volume_flow_unit,
        trans_mass_flow_unit,
        trans_nominal_size_units,
        trans_totalizer_reset,
        trans_reset_error_bit,
	trans_temperature_unit,
	trans_density_unit,
	trans_totalizer_units,
        trans_tb_status_handling,

        // AI1 FUNCTION BLOCK
        func1_AI_target_mode,
        func1_AI_out_unit,
        func1_AI_out_unit_text,
        func1_AI_out_decimal_point,
        func1_AI_pv_ftime,
        func1_AI_pv_lower_range_value,
        func1_AI_pv_upper_range_value
        func1_AI_out_lower_range_value,
        func1_AI_out_upper_range_value,
        func1_AI_hi_hi_lim,
        func1_AI_hi_lim,
        func1_AI_lo_lim,
        func1_AI_lo_lo_lim,
        func1_AI_alarm_hys,


    }
}

//******************************************************************************